/*************************************************************/
/* Copyright (C) 2016 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED.
 * THIS COPYRIGHT STATEMENT MAY NOT BE REMOVED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: iso_ts_24534-3 */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.Libitsivim_asn1 */
/* Created: Tue Jul 26 14:38:15 2016 */
/* ASN.1 Compiler for Java version: 6.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-2016.07.26.14.37.28.183/oss7811412611381924702gen/LibItsIvim_asn1.gen
 * asn/ISO_TS_14906_Generic.asn asn/ITS-Container.asn asn/ISO_TS_17419.asn
 * asn/ISO_TS_14906_Application.asn asn/ISO_TS_14816.asn asn/ISO_TS_19321.asn
 * asn/ISO_TS_24534-3.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type ProtectedCommunicationZone from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class ProtectedCommunicationZone extends Sequence {
    
    /**
     * The default constructor.
     */
    public ProtectedCommunicationZone()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public ProtectedCommunicationZone(ProtectedZoneType protectedZoneType, 
		    TimestampIts expiryTime, Latitude protectedZoneLatitude, 
		    Longitude protectedZoneLongitude, 
		    ProtectedZoneRadius protectedZoneRadius, 
		    ProtectedZoneID protectedZoneID)
    {
	setProtectedZoneType(protectedZoneType);
	setExpiryTime(expiryTime);
	setProtectedZoneLatitude(protectedZoneLatitude);
	setProtectedZoneLongitude(protectedZoneLongitude);
	setProtectedZoneRadius(protectedZoneRadius);
	setProtectedZoneID(protectedZoneID);
    }
    
    /**
     * Construct with required components.
     */
    public ProtectedCommunicationZone(ProtectedZoneType protectedZoneType, 
		    Latitude protectedZoneLatitude, 
		    Longitude protectedZoneLongitude)
    {
	setProtectedZoneType(protectedZoneType);
	setProtectedZoneLatitude(protectedZoneLatitude);
	setProtectedZoneLongitude(protectedZoneLongitude);
    }
    
    public void initComponents()
    {
	mComponents[0] = ProtectedZoneType.permanentCenDsrcTolling;
	mComponents[1] = new TimestampIts();
	mComponents[2] = new Latitude();
	mComponents[3] = new Longitude();
	mComponents[4] = new ProtectedZoneRadius();
	mComponents[5] = new ProtectedZoneID();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[6];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return ProtectedZoneType.permanentCenDsrcTolling;
	    case 1:
		return new TimestampIts();
	    case 2:
		return new Latitude();
	    case 3:
		return new Longitude();
	    case 4:
		return new ProtectedZoneRadius();
	    case 5:
		return new ProtectedZoneID();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "protectedZoneType"
    public ProtectedZoneType getProtectedZoneType()
    {
	return (ProtectedZoneType)mComponents[0];
    }
    
    public void setProtectedZoneType(ProtectedZoneType protectedZoneType)
    {
	mComponents[0] = protectedZoneType;
    }
    
    
    // Methods for field "expiryTime"
    public TimestampIts getExpiryTime()
    {
	return (TimestampIts)mComponents[1];
    }
    
    public void setExpiryTime(TimestampIts expiryTime)
    {
	mComponents[1] = expiryTime;
    }
    
    public boolean hasExpiryTime()
    {
	return componentIsPresent(1);
    }
    
    public void deleteExpiryTime()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "protectedZoneLatitude"
    public Latitude getProtectedZoneLatitude()
    {
	return (Latitude)mComponents[2];
    }
    
    public void setProtectedZoneLatitude(Latitude protectedZoneLatitude)
    {
	mComponents[2] = protectedZoneLatitude;
    }
    
    
    // Methods for field "protectedZoneLongitude"
    public Longitude getProtectedZoneLongitude()
    {
	return (Longitude)mComponents[3];
    }
    
    public void setProtectedZoneLongitude(Longitude protectedZoneLongitude)
    {
	mComponents[3] = protectedZoneLongitude;
    }
    
    
    // Methods for field "protectedZoneRadius"
    public ProtectedZoneRadius getProtectedZoneRadius()
    {
	return (ProtectedZoneRadius)mComponents[4];
    }
    
    public void setProtectedZoneRadius(ProtectedZoneRadius protectedZoneRadius)
    {
	mComponents[4] = protectedZoneRadius;
    }
    
    public boolean hasProtectedZoneRadius()
    {
	return componentIsPresent(4);
    }
    
    public void deleteProtectedZoneRadius()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "protectedZoneID"
    public ProtectedZoneID getProtectedZoneID()
    {
	return (ProtectedZoneID)mComponents[5];
    }
    
    public void setProtectedZoneID(ProtectedZoneID protectedZoneID)
    {
	mComponents[5] = protectedZoneID;
    }
    
    public boolean hasProtectedZoneID()
    {
	return componentIsPresent(5);
    }
    
    public void deleteProtectedZoneID()
    {
	setComponentAbsent(5);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
	    "ProtectedCommunicationZone"
	),
	new QName (
	    "ITS-Container",
	    "ProtectedCommunicationZone"
	),
	274458,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"ProtectedZoneType"
			    ),
			    new QName (
				"ITS-Container",
				"ProtectedZoneType"
			    ),
			    274462,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"permanentCenDsrcTolling",
					0
				    ),
				    new MemberListElement (
					"temporaryCenDsrcTolling",
					1
				    )
				}
			    ),
			    0,
			    ProtectedZoneType.permanentCenDsrcTolling
			)
		    ),
		    "protectedZoneType",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"TimestampIts"
			    ),
			    new QName (
				"ITS-Container",
				"TimestampIts"
			    ),
			    274458,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new TimestampIts(0), 
				    new TimestampIts(4398046511103L),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(4398046511103L)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"utcStartOf2004",
					0
				    ),
				    new MemberListElement (
					"oneMillisecAfterUTCStartOf2004",
					1
				    )
				}
			    )
			)
		    ),
		    "expiryTime",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"Latitude"
			    ),
			    new QName (
				"ITS-Container",
				"Latitude"
			    ),
			    274458,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Latitude(-900000000), 
				    new Latitude(900000001),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-900000000),
				new java.lang.Long(900000001)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeNorth",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeSouth",
					-10
				    ),
				    new MemberListElement (
					"unavailable",
					900000001
				    )
				}
			    )
			)
		    ),
		    "protectedZoneLatitude",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"Longitude"
			    ),
			    new QName (
				"ITS-Container",
				"Longitude"
			    ),
			    274458,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Longitude(-1800000000), 
				    new Longitude(1800000001),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-1800000000),
				new java.lang.Long(1800000001)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeEast",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeWest",
					-10
				    ),
				    new MemberListElement (
					"unavailable",
					1800000001
				    )
				}
			    )
			)
		    ),
		    "protectedZoneLongitude",
		    3,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"ProtectedZoneRadius"
			    ),
			    new QName (
				"ITS-Container",
				"ProtectedZoneRadius"
			    ),
			    274462,
			    new ExtensibleConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new ProtectedZoneRadius(1), 
					new ProtectedZoneRadius(255),
					0
				    )
				),
				null
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMeter",
					1
				    )
				}
			    )
			)
		    ),
		    "protectedZoneRadius",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsIvim_asn1.its_container",
				"ProtectedZoneID"
			    ),
			    new QName (
				"ITS-Container",
				"ProtectedZoneID"
			    ),
			    274458,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new ProtectedZoneID(0), 
				    new ProtectedZoneID(134217727),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(134217727)
			    ),
			    null
			)
		    ),
		    "protectedZoneID",
		    5,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ProtectedCommunicationZone object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ProtectedCommunicationZone object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for ProtectedCommunicationZone
